﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Text.RegularExpressions;
using System.Collections;
using GcDevicePc.Common;
using GcDevicePc.GCBuffer;
using System.Runtime.InteropServices;

namespace GcDevicePc.ProThread
{
    class ChannelDataSave
    {
        ManualResetEvent datamre = new ManualResetEvent(false);
        Thread t_DataSave;
        //int isstart = 0;
        String savefilename;

        #region
        //private void Monitor_Data()
        //{
        //    double time = 0;
        //    double value = 0;

        //    float dtime = 0.0f;
        //    float dvalue = 0.0f;

        //    while (!datamre.WaitOne(500))
        //    {
        //        if ((globaldata.m_hmibuffer.gcinfo.methodstatus == 4 || globaldata.m_hmibuffer.gcinfo.methodstatus == 5) && globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.system_Statue)
        //        {
        //            if (globaldata.m_signalbuffer.Draw_Port.Count > 1)
        //            {
        //                if (globaldata.startclear || globaldata.stopflag || globaldata.cancelflag)
        //                {
        //                    time = 0;
        //                    globaldata.startclear = false;
        //                }

        //                if (globaldata.stopflag)
        //                {
        //                    time = 0;
        //                }
        //                else
        //                {
        //                    //if (globaldata.starttimer == 0)
        //                    //{
        //                    //    globaldata.starttimer = ((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Draw_Port[0]).ctimer;
        //                    //}

        //                    for (int i = 0; i < globaldata.m_signalbuffer.Draw_Port.Count; i++)
        //                    {
        //                        if (globaldata.starttimer <= ((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Draw_Port[i]).ctimer)
        //                        {
        //                            Console.WriteLine("starttimer   " + globaldata.starttimer.ToString());
        //                            time += ((((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Draw_Port[i]).ctimer - globaldata.starttimer) / 1000.0f / 60.0f);
        //                            globaldata.starttimer = ((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Draw_Port[i]).ctimer;
        //                            value = (((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Draw_Port[i]).cdata * 1000.0f);

        //                            dtime = float.Parse(time.ToString("0.0000"));
        //                            dvalue = float.Parse(value.ToString("0.0000"));

        //                            if (globaldata.startflag && globaldata.m_pcbuffer.gcpcinfo.pcfileinfo.cur_DataName != null)
        //                            {
        //                                //AESfile savefile = new AESfile(globaldata.m_pcbuffer.gcpcinfo.pcfileinfo.cur_DataName);
        //                                //savefile.Write_filetw(dtime, dvalue);
        //                            }
        //                        }
        //                    }
        //                }
        //            }
        //           // globaldata.m_signalbuffer.Draw_Port.Clear();                   
        //        }

        //        if (globaldata.cancelflag)
        //        {
        //            if (globaldata.m_pcbuffer.gcpcinfo.pcfileinfo.cur_DataName != null)
        //            {
        //                if (File.Exists(globaldata.m_pcbuffer.gcpcinfo.pcfileinfo.cur_DataName))
        //                {
        //                    File.Delete(globaldata.m_pcbuffer.gcpcinfo.pcfileinfo.cur_DataName);
        //                }
        //            }
        //            globaldata.cancelflag = false;
        //        }

        //        Thread.Sleep(500);
        //    }
        //}
        #endregion

        private long GetCurrentTimeUnix()
        {
            TimeSpan cha = (DateTime.Now - TimeZone.CurrentTimeZone.ToLocalTime(new System.DateTime(1970, 1, 1)));
            long t = (long)cha.TotalSeconds;
            return t;
        }

        private void Monitor_Data()
        {
            double value = 0;
            float dvalue = 0.0f;
            UInt32 starttimer = 0x7FFFFFFF;
            UInt32 endtimer = 0x7FFFFFFF;
            Boolean saveflag = false;
            List<float> listPoint = new List<float>();//临时数据区
            List<float> savePoint = new List<float>();
            List<uint> timePoint = new List<uint>();//临时数据区

            try
            {
                while (!datamre.WaitOne(500))
                {
                    if ((globaldata.m_hmibuffer.gcinfo.methodstatus == 4 || globaldata.m_hmibuffer.gcinfo.methodstatus == 5) || globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.system_Statue)
                    {
                        String tmpFileName = globaldata.m_pcbuffer.gcpcinfo.pcfileinfo.cur_MethodName;
                        String methodfilename = tmpFileName.Substring(tmpFileName.LastIndexOf("\\") + 1);
                        string[] sArray = methodfilename.Split('.');

                        String tmpfolder = Path.Combine(globaldata.m_pcbuffer.gcpcinfo.pcfolderinfo.DataFolder, sArray[0]);
                        if (!Directory.Exists(tmpfolder))
                        {
                            Directory.CreateDirectory(tmpfolder);
                        }


                        tmpfolder = Path.Combine(tmpfolder, DateTime.Now.ToString("yyyyMMdd"));
                        if (!Directory.Exists(tmpfolder))
                        {
                            Directory.CreateDirectory(tmpfolder);
                        }

                        String cur_folder = tmpfolder;
                        String cur_filename = sArray[0] + "_" + DateTime.Now.ToString("yyyy年MM月dd日HH时mm分ss秒") + "_前.hw";

                        savefilename = Path.Combine(cur_folder, cur_filename);

                        lock (globaldata.m_signalbuffer.Save_Port)
                        {
                            if (globaldata.m_signalbuffer.Save_Port.Count > 1)
                            {
                                if (globaldata.m_hmibuffer.gcinfo.methodstatus < 3 || globaldata.m_hmibuffer.gcinfo.methodstatus > 5)
                                {
                                    starttimer = ((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Save_Port[0]).ctimer;
                                    globaldata.m_signalbuffer.Save_Port.Clear();
                                    //if (globaldata.m_hmibuffer.gcinfo.methodstatus > 5 && saveflag)
                                    if (saveflag)
                                    {

                                        starttimer = globaldata.m_hmibuffer.gcinfo.NowStartTime;
                                        endtimer = globaldata.m_hmibuffer.gcinfo.NowEndTime;

                                        int index1 = timePoint.FindIndex(item => item >= starttimer);
                                        int index2 = timePoint.FindLastIndex(item => item <= endtimer);

                                        if (index1 >= 0)
                                        {
                                            if (index2 <= 0)
                                            {
                                                index2 = timePoint.Count;
                                            }
                                        }

                                        if (index2 > index1 && index1 >= 0)
                                        {
                                            savePoint = listPoint.GetRange(index1, index2 - index1);
                                            TWFile twfile = new TWFile(savefilename);
                                            twfile.TW_Open();
                                            for (int j = 0; j < savePoint.Count; j++)
                                            {
                                                twfile.bw.Write((int)(savePoint[j] * 1000));
                                            }
                                            twfile.TW_Close(savePoint.Count);
                                        }
                                        else
                                        {
                                            Log.Info("Channel1 Save Data: " + starttimer.ToString() + "-" + endtimer.ToString());
                                            Log.Info("Channel1 Index1,Index2: " + index1.ToString() + "-" + index2.ToString());
                                            Log.Info("Channel1 timePoint: " + timePoint[0].ToString() + "-" + timePoint[timePoint.Count - 1].ToString());
                                            Log.Info("Channel1 Data Num:" + listPoint.Count.ToString());
                                        }

                                        starttimer = 0x7FFFFFFF;
                                        savePoint.Clear();
                                        saveflag = false;
                                    }
                                }
                                else if (globaldata.m_hmibuffer.gcinfo.methodstatus == 4 || globaldata.m_hmibuffer.gcinfo.methodstatus == 5)
                                {
                                    for (int i = 0; i < globaldata.m_signalbuffer.Save_Port.Count; i++)
                                    {
                                        if (globaldata.m_hmibuffer.gcinfo.NowStartTime <= ((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Save_Port[i]).ctimer)//&& (((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Save_Port[i]).ctimer - starttimer) < 3000)
                                        {
                                            value = (((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Save_Port[i]).cdata * 1000.0f);
                                            dvalue = (float)Math.Round(value, 4);

                                            lock (timePoint)
                                            {
                                                //if (globaldata.startflag) //&& globaldata.m_pcbuffer.gcpcinfo.pcfileinfo.cur_DataName != null)
                                                {
                                                    timePoint.Add(((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Save_Port[i]).ctimer);
                                                    listPoint.Add(dvalue);
                                                    saveflag = true;
                                                }
                                            }

                                        }
                                    }
                                    globaldata.m_signalbuffer.Save_Port.Clear();
                                }
                                else
                                {
                                    listPoint.Clear();
                                    timePoint.Clear();
                                    //Console.WriteLine("等待开始按钮!");
                                    if (!globaldata.startflag)
                                    {
                                        globaldata.m_signalbuffer.Save_Port.Clear();
                                    }
                                    else
                                    {
                                        starttimer = ((SignalBuffer.Channel_XY)globaldata.m_signalbuffer.Save_Port[0]).ctimer;
                                    }
                                }


                            }
                        }
                    }

                    if (globaldata.cancelflag1)
                    {
                        if (this.savefilename != null)
                        {
                            if (File.Exists(this.savefilename))
                            {
                                File.Delete(this.savefilename);
                            }
                        }
                        globaldata.cancelflag1 = false;
                    }
                }
            }
            catch (Exception ex)
            {
                Log.Error("Channel 1 Data Save Crash!");
                Log.Error(ex.Message);
            }

        }
        public void ChannelDataStart()
        {
            if( datamre != null)
            {
                datamre.Reset();
            }
            t_DataSave = new Thread(Monitor_Data);
            t_DataSave.IsBackground = true;
            t_DataSave.Start();
        }

        public void ChannelDataStop()
        {
            datamre.Set();
        }


    }
}
